/*
  Designed by LinJiangHua(xempo) 2003-2006
  Copyright 2004-2006,2008-2010 Linjianghua(xempo).
  All Rights Reserve.
*/

#include "storplus.def"

char p_DirFlags[]="\\";

static const char rootchs[]="\\/";

DIRE *DirRead(Dysto *srl,long adr)
{
 if(adr<10)return NULL;
 if(srl->cDir==NULL||srl->cDir->selfaddr!=adr){
  DIRE *Dir=DIRalloc();
  dkread(srl,Dir,srl->DirSize,1,adr);
  return Dir;
 }
 else return srl->cDir;
}

unsigned long PassWord(DIRE *dir)
{
 int j=0;
 unsigned long i, pswd=0;
 NewScrLine();
 printf(dir->name);
 if(Inpdat(ConBuf," Password:",genkmsg)==ENTER)
	for(i=1;ConBuf[j];j++,i++){
		pswd+=i*ConBuf[j]<<j%13;
		dir->realtime+=(i<<5)*ConBuf[j];
	}
 else return 1;
 dir->tmpchr=j? ConBuf[j-1]:0;
 return pswd+j;
}

bool pwdcrc(Dysto *dys,DIRE *Dir)
{
if(PassWord(Dir)!=Dir->password||Dir->tmpchr!=Dir->pwdchr){
	popMsg("Incorrect password !\n",NULL,0);
	Release(dys,Dir); DysMsg=5;
	return false;
	}
return true;
}

int adrOffect(DIRE *Dir){ return Dir->realtime%956+Dir->pwdchr; }

void DirInit(Dysto *dys,DIRE *Dir)
{
int msg=Dir->Format;
if(/*Dir->usemsg==1 useful &&*/Dir->realtime){
 long fix=adrOffect(Dir);
 if(Dir->storanmb)Dir->nmbadr=Dir->storanmb-fix;/* same type is fit to size */
 if(Dir->storadir)Dir->subDir=Dir->storadir-fix;
}
if(dys->verNo>2){
  Dir->dau=msg;
  Dir->statLen= (Dir->datelog? 9:5) + msg * sizeof(DAU);
}
else { 
  Dir->dau=msg>sg_dat? 2:1;
  Dir->datelog=(msg-5)%8;
/*  Dir->mode */
  Dir->statLen=msg;
}
Dir->PosDAU=Dir->datelog? 9:5;
}

void _release(Dysto *srl,DIRE *Dir)
{
if(Dir){
   if(Dir->mdf){
	if(Dir->realtime){
	long /* same type is fit to size */fix=adrOffect(Dir);
	  if(Dir->nmbadr)Dir->storanmb=Dir->nmbadr+fix; /* same type is fit to size */
	  if(Dir->subDir)Dir->storadir=Dir->subDir+fix;
	  Dir->nmbadr=0; Dir->subDir=0; /* safe for PC */
	}
	dkwrite(srl,Dir,srl->DirSize,Dir->selfaddr);
	}
   free(Dir);
   }
}

void Release(Dysto *srl,DIRE *dir)
{
if(dir!=srl->cDir)_release(srl,dir);
}

DIRE *DirFix(Dysto *srl,const char *dirnam,long pDir)
{/* this pDir is unsure dirnam's selfaddr,
it's Dir link first adr of this class */
DIRE *Dir;
while((Dir=DirRead(srl,pDir))!=NULL){
  pDir=Dir->nx;
  switch(Dir->usemsg){
  case 1 : 
	if((strchrs(rootchs,dirnam)==NULL||dirnam[1])/* not root-dir */
		&&stricmp(Dir->name,dirnam))
	GoOn:	Release(srl,Dir);
	else return Dir;/* dirnam==p_DirFlags or Dir->name==dirnam */
	break;
  case 0 : goto GoOn;
  default :
	  if(dirnam==SPC&&Dir->date<srl->date)/* redir */return Dir;
	  if(dirnam==dysver&&Dir->date>srl->date)/* unddel */return Dir;
   }
  }
return NULL;
}


DIRE *_diropen(Dysto *srl,const char *sendnam,int creatmsg)
{/* #define GetRoot(lib) DirRead(lib,lib->DirAdr)
padr: 0 is get exist, 1 get path(Parent, often use for create one Dir)
return is flag. */
DIRE *Dir, *cDir;
int Info=1;
long adr;
char *pName, *pt, *dirnam;
if(srl==NULL){ DysMsg=2; return NULL; }
DysMsg=0x7fff; cDir=srl->cDir;
if(sendnam==NULL)return cDir;
/*------------------ get special path ------------------*/
if(*sendnam=='.'&&sendnam[1]=='.'){
p_dir:	if(cDir==NULL){ DysMsg=6; return NULL; }
	Dir=DirRead(srl,cDir->parDir);
	Release(srl,cDir); cDir=Dir;
	switch((++sendnam)[1]){
	case '.' :  goto p_dir;
	case '/' :
	case '\\' : sendnam++;
	case 0 : sendnam++; break;
	default : DysMsg=6; return NULL;
	}
  }
  else if(*sendnam=='.')switch( sendnam[1] ){
		case '/' :
		case '\\': sendnam++; /* self-own */
		case 0 : sendnam++;
		}
/* ------------------- get special path end ----------------- */
  if(*sendnam==0)return cDir;
  dirnam=strdup(sendnam);
  pt=strchrs(dirnam,rootchs); pName=NULL;
  do{
	if(pt==dirnam){ Info=0; adr=srl->DirAdr; pName=pt+1; }
	else {	adr=GetAddress(srl,cDir);
		pName = pName? pt+1:dirnam;
		}
	if((pt=strchrs(pName,rootchs))!=NULL)*pt=0;
	Info++;
	if((Dir=DirFix(srl,pName,adr))==NULL){
	  if(pt||creatmsg==false){
		if(*pName)DysMsg=6;
		err1: Release(srl,cDir);
		}
	  else Dir=cDir!=srl->cDir||Info>1? cDir:NULL;/* new Dir's parent */
	break;
	}
	Release(srl,cDir);	cDir=Dir;
	if(pt==NULL&&creatmsg){ Dir=NULL; DysMsg=7; goto err1; } 
  }while(pt);
  free(dirnam);
  return Dir;
}
